unit VolgaReg;
{$DEFINE PRO}
{$IfnDef Linux}
  { $DEFINE SERV}
{$EndIf non-Linux}

{$IFDEF VER125}      // Borland C++ Builder 4.0
  {$DEFINE CBUILDER}
{$ENDIF}

{$IFDEF VER130}      // Borland C++ Builder 5.0
 {$IFDEF BCB}
  {$DEFINE CBUILDER}
 {$ENDIF}
{$ENDIF}

{$IFDEF VER140}      // Borland C++ Builder 6.0
 {$IFDEF BCB}
  {$DEFINE CBUILDER}
 {$ENDIF}
{$ENDIF}

{$IFDEF VER180}      // Borland Delphi2006
{$IFDEF BCB}
  {$DEFINE CBUILDER}
{$ELSE}
  {$DEFINE D10}
 {$ENDIF}
{$ENDIF}

interface
uses Forms, Classes, DB, {vn: Db -> DB (Linux names are case sensitive!)}
{$IFDEF VER140}DesignIntf, DesignEditors,{$ENDIF}
//{$ELSE}
{$IFDEF VER150}DesignIntf, DesignEditors,{$ENDIF}
//{$ELSE}
{$IFDEF VER130}DsgnIntf,{$ENDIF}
//{$ELSE}
{$IFDEF VER125}DsgnIntf,{$ENDIF}
//{$ELSE}
{$IFDEF VER180}DesignIntf, DesignEditors,
{$ENDIF}
//{$ENDIF}
  SysUtils,
{$IfDef Linux}
  QForms, QDialogs, QStdCtrls,
{$Else}
  {Forms,} Dialogs, StdCtrls,
{$EndIf Linux}
{$IFNDEF CBUILDER}{$IfnDef Linux} DBTables, DBReg,{$EndIf non-Linux}{$ENDIF}
{$IfDef Linux}
  QExtCtrls, QControls, QButtons,
{$Else}
  ExtCtrls, Controls, Buttons,
{$EndIf Linux}
  FileCtrl;

//********* PropertyEditor for table name **************************************

type
  TDTableNameProperty = class(TStringProperty)
  public
    function GetAttributes: TPropertyAttributes; override;
    procedure GetValues(Proc: TGetStrProc); override;
    procedure Edit; override;
  end;

//********* PropertyEditor for database path ***********************************

  TDDatabaseNameProperty = class(TStringProperty)
  public
    function GetAttributes: TPropertyAttributes; override;
    procedure Edit; override;
  end;

//********* ComponentEditor for TVolgaTable ************************************
{$IFNDEF CBUILDER}
{$IfnDef Linux}
  TVolgaTableEditor = class(TDataSetEditor)
  protected
    procedure BorrowStru;
    procedure Save;
  public
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerb(Index: Integer): string; override;
    function GetVerbCount: Integer; override;
  end;
{$EndIf non-Linux}
{$ENDIF}

procedure Register;

implementation

{$R 'VolgaDB.dcr'}

uses VolgaTbl, {$IFDEF PRO}VolgaQry,
{$IFDEF SERV}VolSrvQry, {$ENDIF}
{$ENDIF}
  VolgaConst;

procedure Register;
begin
{$IFDEF SERV}
  RegisterComponents('Volga', [TVolgaTable, TVolgaQuery, TVolgaServQuery, TVolgaDatabase]);
{$ELSE}
{$IFDEF PRO}
  RegisterComponents('Volga', [TVolgaTable, TVolgaQuery, TVolgaDatabase]);
{$ENDIF}
{$ENDIF}
  RegisterComponents('Volga', [TVolgaTable, TVolgaDatabase]);
{$IFNDEF CBUILDER}
{$IfnDef Linux}
  RegisterComponentEditor(TVolgaTable, TVolgaTableEditor);
{$EndIf non-Linux}
{$ENDIF}
  RegisterPropertyEditor(TypeInfo(string), TVolgaTable, 'TableName', TDTableNameProperty);
  RegisterPropertyEditor(TypeInfo(string), TVolgaDatabase, 'DatabasePath', TDDatabaseNameProperty);
end;

//******************************************************************************
//          Property Editor for property TableName
//******************************************************************************

procedure TDTableNameProperty.Edit;
var FileOpen: TOpenDialog;
begin
  FileOpen := TOpenDialog.Create(Application);
  FileOpen.DefaultExt := 'd';
  FileOpen.FileName := GetValue;
  FileOpen.Filter := V_OPENDLGFILT;
  if FileOpen.Execute then begin
    SetValue(FileOpen.FileName);
  end;
  FileOpen.Free;
end;

function TDTableNameProperty.GetAttributes: TPropertyAttributes;
var V: TVolgaTable;
begin
  V := TVolgaTable(GetComponent(0)); //first of selected
  if (V.Database <> nil)
{$IFDEF SERV}
  and (V.Database.DriverName = vdnVolga)
{$ENDIF}
  and (V.Database.DatabasePath > '') then
    Result := [paValueList, paSortList, paRevertable]
  else Result := [paDialog, paRevertable];
end;

procedure TDTableNameProperty.GetValues(Proc: TGetStrProc);
var I, rez: Integer;
  Values: TStringList;
  V: TVolgaTable;
  SearchRec: TSearchRec;
begin
  Values := TStringList.Create;
  V := TVolgaTable(GetComponent(0)); //first of selected
  try
    //create dropdown list of all *.d in folder
    rez := FindFirst(V.Database.DatabasePath + '*.d', faAnyFile, SearchRec);
    if rez = 0 then begin
      Values.Add(SearchRec.Name);
      while (FindNext(SearchRec) = 0) do
        Values.Add(SearchRec.Name);
    end;
    FindClose(SearchRec);
    for I := 0 to Values.Count - 1 do Proc(Values[I]);
  finally
    Values.Free;
  end;
end;

{TDDatabaseNameProperty}

procedure TDDatabaseNameProperty.Edit;
var dir: {$IfDef Linux}widestring;{$Else}string;{$EndIf Linux}
begin
  inherited;
  dir := GetValue;
{$IfDef Linux}
  if QDialogs.SelectDirectory(V_OPENDIRECTORY, '', dir, true) then
{$Else}
  if SelectDirectory(V_OPENDIRECTORY, '', dir) then
{$EndIf Linux}
    SetValue(dir);
end;

function TDDatabaseNameProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paMultiSelect, paDialog, paRevertable];
end;

//**************************************************************************
// TVolgaTableEditor - component editor for TVolgaTable
//**************************************************************************
{$IFNDEF CBUILDER}
{$IfnDef Linux}
procedure TVolgaTableEditor.BorrowStru;
var EditVT, tblClone: TVolgaTable;
  Table1: TTable; ext, FileName: string;
  FileOpen: TOpenDialog;
begin
  FileOpen := TOpenDialog.Create(Application);
  FileOpen.DefaultExt := 'd';
  FileOpen.Filter := V_OPENALLDLGFILT;
  if FileOpen.Execute then
    FileName := FileOpen.FileName
  else FileName := '';
  FileOpen.Free;
  if FileName > '' then
  begin
    EditVT := TVolgaTable(Component);
    ext := ExtractFileExt(FileName);
    try
      if (UpperCase(ext) = '.DB') or (UpperCase(ext) = '.DBF') then
      begin
        Table1 := TTable.Create(nil);
        Table1.TableName := FileName;
        Table1.Open;
        EditVT.BatchMove(Table1, vbmCopyDef); //copy structure
        Table1.Close;
        Table1.Free;
      end
      else
      begin
        tblClone := TVolgaTable.Create(nil);
        tblClone.LoadFromFile(FileName);
        EditVT.BatchMove(tblClone, vbmCopyDef); //copy structure
        tblClone.Close;
        tblClone.Free;
      end;
      ShowMessage('Borrow structure: executed.');
    except
      raise;
    end;
  end;
end;

procedure TVolgaTableEditor.ExecuteVerb(Index: Integer);
begin
  case Index of
    0: inherited;
    1: BorrowStru;
    2: Save;
  end;
end;

function TVolgaTableEditor.GetVerb(Index: Integer): string;
begin
  case Index of
    0: Result := inherited GetVerb(Index);
    1: Result := 'Borrow structure...';
    2: Result := 'Save to file...';
  end;
end;

function TVolgaTableEditor.GetVerbCount: Integer;
begin
  Result := inherited GetVerbCount + 2;
end;

procedure TVolgaTableEditor.Save;
var SaveDialog: TSaveDialog;
begin
  SaveDialog := TSaveDialog.Create(nil);
  SaveDialog.DefaultExt := 'd';
  SaveDialog.Filter := V_OPENDLGFILT;
  SaveDialog.FileName := 'new';
  if SaveDialog.Execute and TVolgaTable(Component).Active then
    TVolgaTable(Component).SaveToFile(SaveDialog.FileName);
  SaveDialog.Free;
end;
{$EndIf non-Linux}
{$ENDIF}

end.
